<?php
/**
* @version 			SEBLOD 3.x Core ~ $Id: index.php sebastienheraud $
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2013 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

defined( '_JEXEC' ) or die;

// -- Initialize
require_once dirname(__FILE__).'/config.php';
$cck	=	CCK_Rendering::getInstance( $this->template );
if ( $cck->initialize() === false ) { return; }

$table_header	=	$cck->getStyleParam( 'table_header', 0 );
$table_layout	=	$cck->getStyleParam( 'table_layout', '' );
$table_width	=	0;
$isFixed		=	( $table_layout == 'fixed' ) ? 1 : ( ( $table_layout == 'calculated' ) ? 2 : 0 );
$class_table	=	trim( $cck->getStyleParam( 'class_table', 'category zebra table' ) );
$class_table	=	( $isFixed ) ? $class_table.' fixed' : $class_table;

$class_table	.=	' Pulsar-table2x ';

$class_table	=	$class_table ? ' class="'.$class_table.'"' : '';
$class_row0		=	trim( $cck->getStyleParam( 'class_table_tr_even', 'cat-list-row%i' ) );
$class_row0		=	$class_row0 ? str_replace( '%i', '0', $class_row0 ) : '';
$class_row1		=	trim( $cck->getStyleParam( 'class_table_tr_odd', 'cat-list-row%i' ) );
$class_row1		=	$class_row1 ? str_replace( '%i', '1', $class_row1 ) : '';

$doc	=	JFactory::getDocument();
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$cck->template. '/css/'.'style.css' );


$filterxMode	=	trim( $cck->getStyleParam( 'filterx_mode', '' ) );
$filteryMode	=	trim( $cck->getStyleParam( 'filtery_mode', '' ) );
$xfilters		=	trim( $cck->getStyleParam( 'filterx', '' ) );
$yfilters		=	trim( $cck->getStyleParam( 'filtery', '' ) );


if($filterxMode == 0){
	$tmp =explode(',', $xfilters);
	$array_x = array();
	
	foreach($tmp as $value){
		if(strpos($value,'=')){
			$value = explode("=",$value);
			$index = $value[0];
			$value = $value[1];
		}
		$array_x[$index] = $value;
	}
}elseif ($filterxMode == 1){
	
	// Language Detection
	$lang_code		=	'';
	
	jimport( 'joomla.language.helper' );
	$languages	=	JLanguageHelper::getLanguages( 'lang_code' );
	$lang_tag	=	JFactory::getLanguage()->getTag();
	$lang_code	=	( isset( $languages[$lang_tag] ) ) ? strtoupper( $languages[$lang_tag]->sef ) : '';
	
	$query			=	str_replace( '[lang]', $lang_code, $xfilters );
	$query			=	JCckDevHelper::replaceLive( $query );
	
	if ( ( ( strpos( $query, ' value ' ) !== false ) || ( strpos( $query, 'AS value' ) !== false ) || ( strpos( $query, ' value,' ) !== false ) ) && (( strpos( $query, ' text ' ) !== false ) || ( strpos( $query, 'AS text' ) !== false ) || ( strpos( $query, ' text,' ) !== false )) ) {
		$itemsx	=	JCckDatabase::loadObjectList( $query );
	} else {
		throw Exception('Error, no value specified in the query =>'.$query);
	}
	
	foreach($itemsx as $item){
		$array_x[$item->text] = $item->value;
	}
}

if($filteryMode == 0){
	$tmp =explode(',', $yfilters);
	$array_y = array();

	foreach($tmp as $value){
		if(strpos($value,'=')){
			$value = explode("=",$value);
			$index = $value[0];
			$value = $value[1];
		}
		$array_y[$index] = $value;
	}
}elseif ($filteryMode == 1){
	// Language Detection
	$lang_code		=	'';
	
	jimport( 'joomla.language.helper' );
	$languages	=	JLanguageHelper::getLanguages( 'lang_code' );
	$lang_tag	=	JFactory::getLanguage()->getTag();
	$lang_code	=	( isset( $languages[$lang_tag] ) ) ? strtoupper( $languages[$lang_tag]->sef ) : '';
	
	$query			=	str_replace( '[lang]', $lang_code, $yfilters );
	$query			=	JCckDevHelper::replaceLive( $query );
	
	if ( ( ( strpos( $query, ' value ' ) !== false ) || ( strpos( $query, 'AS value' ) !== false ) || ( strpos( $query, ' value,' ) !== false ) ) && (( strpos( $query, ' text ' ) !== false ) || ( strpos( $query, 'AS text' ) !== false ) || ( strpos( $query, ' text,' ) !== false )) ) {
		$itemsy	=	JCckDatabase::loadObjectList( $query );
	} else {
		throw Exception('Error, no value specified in the query =>'.$query);
	}
	
	foreach($itemsy as $item){
		$array_y[$item->text] = $item->value;
	}
}

if(! (count($array_x) && count($array_y)) )
	return;

// TODO change name
$fieldnames_xfilter	=	$cck->getFields( "filter-x", '', false );
$fieldnames_yfilter	=	$cck->getFields( "filter-y", '', false );
$fieldnames_show	=	$cck->getFields( "showdata", '', false );
$fieldnames_allx	=	$cck->getFields( "allx", '', false );
if(!(count($fieldnames_xfilter) && count($fieldnames_yfilter) && count($fieldnames_show) ) )
	return;

// -- Render
?>
<div id="<?php echo $cck->id; ?>" class="<?php echo $cck->id_class; ?>cck-f100 cck-pad-<?php echo $cck->getStyleParam( 'position_margin', '10' ); ?>">
    <div>
    <?php
	$attr		=	array(
						'class'=>array(),
						'width'=>array()
					);
	$items		=	$cck->getItems();
	
	$positions	=	$cck->getPositions();
	unset( $positions['hidden'] );
	if ( count( $items ) ) { ?>
		<table<?php echo $class_table; ?>>
			<?php
			$head	=	'<th></th>';
			$thead	=	false;
			
			/// here only 2 positions, filter1 and filter2, and check filter1, filter2 and show_column
			
			if(! (isset($positions['filter-x']) &&  isset($positions['filter-y']) && isset($positions['showdata'])) )
				return;

			foreach(array_keys($array_x) as $xlabel){
				$head	.=	'<th class="center" >'.$xlabel.'</th>';
			}
            ?>
            
            
            <?php
            	if ( $head && ( $table_header == 0 || $table_header == 1 ) ) {
           	 ?>
            <thead>
                <tr class="head_x" ><?php echo $head; ?></tr>
			</thead>
			<?php } ?>
            <tbody>
            <?php
            
			$y = 0;
			
			foreach($array_y as $ylabel=>$yval){
				$tr_y = '<tr ';
				$tr_y_class = "class = '".${'class_row'.($y % 2)}.' class_row_'.$y. " ";				
				$rowHtmly = '<td class="ylabel">'.$ylabel.'</td>';
				$rowHtmlyMedia = '<td class="media">';
				$rowHtmlx = '';
				$x = 0;
				
				$allx = false;
				
				foreach($array_x as $xlabel=>$xval){

					if($allx)
						break;
					$rowHtmlx	.=	'<td class="center no-media">';

					/*@var   $item CCK_Item */
					foreach ( $items as $item ) {

						$html = '';
						$xfilter = $yfilter = false;
						foreach($fieldnames_yfilter as $fieldname){
							$val = $item->get($fieldname)->value;
							if($val == $yval){
								$yfilter = true;
								break;
							}	
						}

						if($yfilter){
							$xfilter = $allx = false;
							foreach($fieldnames_xfilter as $fieldname){

								$val = $item->get($fieldname)->value;
								if($val == $xval){
									$xfilter = true;
									break;
								}
							}
							foreach ( $fieldnames_allx as $fieldname ) {
								$allx = $item->get($fieldname)->value;
								if($allx)
									break;
							}
						}
						
						if($xfilter || $allx){ // we do show data only here
							$html = '';
							foreach ( $fieldnames_show as $fieldname ) {
								$content	=	$item->renderField( $fieldname );
								if ( $content != '' ) {
									$html	.=	'<div class="cck-clrfix'.$item->getMarkup_Class( $fieldname ).' '.$fieldname.'">'.$content.'</div>';
								}
								
							}
							/*
							foreach ( $fieldnames_allx as $fieldname ) {
								$allx = $item->get($fieldname)->value;								
								if($allx)
									break;
							}*/
							
							unset($items[$item->pk]);
							if($allx){
								$tr_y_class .= " all_rows ";
								$rowHtmlx = '<td'.$attr['class'][$name].$width.' colspan="999" class="allx_td">'.$html;
								break;
							}
							else{
								$rowHtmlx .= $html;
							}
							
							$rowHtmlyMedia	.= 	"<div class='itemMedia'>".$html.$xlabel."</div>";
						}
						
					}
					
					$rowHtmlx .= '</td>';
					
					
				}
				$rowHtmlyMedia.= '</td>';
				$tr_y_class .= "'";
				
				
				$tr_y .= $tr_y_class.' >';
				echo $tr_y.$rowHtmly.$rowHtmlx.$rowHtmlyMedia.'</tr>';
				$y++;
			}
			
			?>
			</tbody>
			<?php
			if ( $head && $thead && ( $table_header == -1 || $table_header == 1 ) ) { ?>
            <tfoot>
                <tr><?php echo $head; ?></tr>
			</tfoot>
			<?php } ?>
		</table>
	<?php } ?>
    </div>
</div>
<?php
// -- Finalize
if ( $table_width ) {
	$cck->addCSS( '#'.$cck->id.' table {min-width:'.$table_width.'px;}' );
}
$cck->finalize();

?>